<?php

/* --- kontrola jadra --- */
if(!defined('_core'))
	exit;

if (_logincounter && _loginright_adminusers)
{
	if (false === DB::query("SELECT * FROM `". _mysql_prefix ."-usergroup`", true))
	{	// nejsou vytvoreny tabulky
		$output .= _formMessage(2, "Plugin \"User Group\" doposud nebyl nainstalován. Instalaci provedete v Nastavení systému => <a href='index.php?p=settings-plugins'>Spravovat rozšíření</a>.");
		return;
	}

	$config = include _plugin_dir . 'usergroup/config.php';
	
	$output .= "<p>Uživatele nastavíte do vybrané skupiny zadáním skupiny a datumu do kdy má být ve skupině zařazen. V případě nevyplnění datumu do je doba neomezena.</p>";
	
	
	$grouplimit = "";
	$grouplimit2 = "1";
	
	$group_search = (int) _get('group', -1);
	if ($group_search !== -1)
	{
			$grouplimit = " AND g.id=" . DB::esc($group_search);
			$grouplimit2 = "`group`=" . DB::esc($group_search);
	}
	
	if (isset($_GET['set']) AND $_GET['set'] != 0)
	{
		$group = (int) DB::esc(_post('group', 1));
		
		$data = array(
			'user_id'   => DB::esc(_get('set')),
			'group_id'  => DB::esc(_post('group_id', null)),
			'group_id_in'  => $group,
			'group_in' => _loadTime('group_in', time()),
			'group_out' => _loadTime('group_out', null),
		);
		
		if (null !== $data['group_id'])
		{
			if ($last_id = DB::insert(_mysql_prefix . "-usergroup", $data, true))
			{
				if ($data['group_in'] <= time())
				{
					if (DB::update(_mysql_prefix . "-users", "id=". $data['user_id'], array("group" => $group)))
					{
						$output .= _formMessage(1, $_lang['global.saved']);
					}
					else
					{
						DB::query("DELETE FROM `". _mysql_prefix . "-usersgroup` WHERE id='". $last_id ."'");
						$output .= _formMessage(2, $_lang['global.error'] .' 1');
					}
				}
				else
				{
					$output .= _formMessage(1, $_lang['global.saved'] .' Změna skupiny bude provedena v nastaveném čase.');
				}
			}
			else
			{
				$output .= _formMessage(2, $_lang['global.error'] .' 2');
			}
		}
		else
		{
			$output .= _formMessage(2, $_lang['global.error'] .' 3');
		}
	}
	
	if (isset($_GET['del']) AND $_GET['del'] != 0)
	{
		$id = DB::esc(_get('del'));
	
		if (DB::query("UPDATE `" . _mysql_prefix . "-users` u 
			INNER JOIN `" . _mysql_prefix . "-usergroup` ug ON (u.id = ug.user_id) 
			SET u.group = ug.group_id 
			WHERE ug.user_id={$id}"))
		{
			DB::query("DELETE FROM `" . _mysql_prefix . "-usergroup` WHERE user_id='" . $id . "'");
			$output .= _formMessage(1, $_lang['global.saved']);
		}
		else
		{
			$output .= DB::error();
		}
	}

	$output .= '
		<table class="wintable">
			<tr>
				<td>
					<form class="cform" action="index.php" method="get">
						<input type="hidden" name="p" value="usergroup" />
						<input type="hidden" name="search"' . _restoreGetValue('search', '') . ' />
						<strong>' . $_lang['admin.users.list.groupfilter'] . ':</strong> '
						. _admin_authorSelect("group", $group_search, "id!=2", null, $_lang['global.all'], true) . '
						<input type="submit" value="' . $_lang['global.apply'] . '" />
					</form>
				</td>
			</tr>
		</table>
		';
	
	$paging = _resultPaging("index.php?p=usergroup&amp;group=" . $group_search, 50, "users", $grouplimit2);
	$output .= $paging[0];
	
	$output .= "<br />
		<table class='list'><thead>
			<tr>
				<td>ID</td>
				<td>" . $_lang['login.username'] . "</td>
				<td>" . $_lang['global.group'] . "</td>
				<td>Nová / <i>Původní</i></td>
				<td>Platí od - do</td>
				<td>akce</td>
			</tr></thead>
		<tbody>
		";
	
	$skupina = optGroup();
	
	$query = DB::query("SELECT u.id, u.group, u.username, u.publicname, u.levelshift, u.email, g.title, g.icon, ug.id AS usergroup, ug.group_id_in, ug.group_in, ug.group_out, g1.title AS title_old, g2.title AS title_new FROM `" . _mysql_prefix . "-users` u LEFT JOIN `" . _mysql_prefix . "-usergroup` ug ON u.id=ug.user_id LEFT JOIN `" . _mysql_prefix . "-groups` g1 ON ug.group_id=g1.id  LEFT JOIN `" . _mysql_prefix . "-groups` g2 ON ug.group_id_in=g2.id, `" . _mysql_prefix . "-groups` g WHERE u.`group`=g.id" . $grouplimit . " ORDER BY g.level DESC, u.username " . $paging[1]);
	
	if (DB::size($query) != 0)
	{
		while ($item = DB::row($query))
		{
			$output .= "<tr>";
			$output .= "<td>" . $item['id'] . "</td>";
			$output .= "<td>" . (($item['icon'] != "") ? "<img src='" . _indexroot . "pictures/groupicons/" . $item['icon'] . "' alt='icon' class='groupicon' /> " : '') . "<a href='index.php?p=users-edit&amp;id=" . $item['username'] . "'>" . (($item['levelshift'] == 1) ? "<strong>" : '') . $item['username'] . (($item['levelshift'] == 1) ? "</strong>" : '') . "</a></td>";
			$output .= "<td>" . $item['title'] . "</td>";
			if ($item['id'] == 0)
			{
				$output .= "<td colspan='4'>nelze nastavit</td>";
			}
			else
			{
				if ($item['usergroup'])
				{
					$output .= '<td>'. ($item['group'] == $item['group_id_in'] ? '<i>'. $item['title_old'] .'</i>' : $item['title_new']) .'</td>';
					$output .= '<td>'. ($item['group_in'] ? _formatTime($item['group_in']) : "neuvedeno");
					$output .= ' - '. ($item['group_out'] ? _formatTime($item['group_out']) : "neomezeno") .'</td>';
					$output .= "<td><a href='" . _xsrfLink("index.php?p=usergroup&amp;del=" . $item['id']) . "' onclick='return _sysConfirm();'><img src='images/icons/delete.png' alt='del' class='icon' />vymazat</a></td>";
				}
				else
				{
					$output .= '<td><form action="index.php?p=usergroup&amp;set='. $item['id'] .'" method="post"><select name="group">';
					foreach ($skupina AS $key => $value)
					{
						if ($item['group'] != $key)
						{
							$output .= '<option value="'. $key .'">'. $value .'</option>';
						}
					}
					$output .= '</select></td>';
					$output .= '<td>Od: '. _editTime('group_in', mktime(date("H"), date("i"), '0', date("m"), (date("d") + $config['den_od']), date("Y")));
					$output .= '<br />Do: '. _editTime('group_out', mktime('23', '59', '59', date("m"), (date("d") + $config['den_do']), date("Y"))) .'</td>';
					$output .= '<td><input type="hidden" name="group_id" value="'. $item['group'] .'" /><input type="hidden" name="_security_token" value="'. _xsrfToken() .'" /><input type="submit" value="Nastavit" /></form></td>';
				}
			}
			$output .= "</tr>\n";
		}
	}
	else
	{
		$output .= "<tr><td colspan='6'>" . $_lang['global.nokit'] . "</td></tr>\n";
	}
	
	$output .= "</tbody></table>";
	
	$totalusers = DB::count(_mysql_prefix . "-users");
	$output .= "\n<br />" . $_lang['admin.users.list.totalusers'] . ": " . $totalusers;
}
else
{
	$output.=_formMessage(3, $_lang['global.disallowed']);
}

Function optGroup()
{
	$query = DB::query("SELECT id, title FROM `" . _mysql_prefix . "-groups` WHERE id>1 ORDER BY level DESC");
	while ($item = DB::row($query))
	{
		$skupina[$item['id']] = $item['title'];
	}

	return (array) $skupina;
}
