<?php

/* ----- kontrola jadra ----- */

if(!defined('_core'))
	exit;

/* ----- funkce ----- */

Function installUG()
{
	$query = DB::query("CREATE TABLE `". _mysql_prefix ."-usergroup` (
		id int(11) unsigned NOT NULL auto_increment,
		user_id int(11) NOT NULL,
		group_id int(11) NOT NULL,
		group_id_in int(11) NOT NULL,
		group_in int(11) NOT NULL,
		group_out int(11) DEFAULT NULL,

		PRIMARY KEY (id)
		) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1", true);

	if ($query == FALSE)
	{
		return _formMessage(3, "Tabulky již existují, nebo se je nepodařilo vytvořit, prosím, opakujte akci.");
	}
	else
	{
		return _formMessage(1, "Databázové tabulky byly vytvořeny. Instalace pluginu byla dokončena.");
	}
}

/* ----- pozadavek deinstalace ----- */
if (_post('deinstall'))
// potvrzeni deinstalace
{
	$query = DB::query("DROP TABLE `". _mysql_prefix ."-usergroup`");

	$output .= _formMessage(1, "Databázové tabulky byly odinstalovány.");
	$output .= "Pro kompletní odstranění pluginu vymažte, prosím, adresáře:
<ul>
		<li><code>plugins/admin/usergroup/</code></li>
		<li><code>plugins/common/usergroup/</code></li>
		<li><code>plugins/extend/usergroup/</code></li>
</ul>";
	return;
}

/* ----- akce ----- */

// priprava optionu pro select
function _renderOptions(array $options, $default)
{
	$opts = "";
	foreach ($options as $key => $value)
	{
		$opts.= "<option value='{$key}'" . ($default === $key ? ' selected' : '') . ">{$value}</option>\n";
	}
	return $opts;
}

$cron = array(
	'1m'	=> '1 minuta',
	'2m'	=> '2 minuty',
	'5m'	=> '5 minut',
	'10m'	=> '10 minut',
	'15m'	=> '15 minut',
	'30m'	=> '30 minut',
	'1h'	=> '1 hodina',
	'2h'	=> '2 hodiny',
	'5h'	=> '5 hodin',
	'12h'	=> '12 hodin',
	'24h'	=> '24 hodin',
);

// cara
$output .= '<div class="hr"><hr /></div>';

switch($action) {

	case 'config':

		// nacteni konfigurace
		$cfg = _pluginLoadConfig($plugin);

		// ulozeni
		if (_post('save'))
		{
			$cfg['den_od'] = _post('den_od', '0');
			$cfg['den_do'] = _post('den_do', '0');
			$cfg['cron'] = _post('cron', '12h');

			// ulozit
			if (false !== _pluginSaveConfig($plugin, $cfg))
			{
				$output .= _formMessage(1, $_lang['global.saved']);
			}
			else
			{
				$output .= _formMessage(2, $_lang['global.error']);
			}
		}

		// formular
		$output .= '
<fieldset id="settingsform">
	<legend>Nastavení</legend>
	<form action="'.$url.'" method="post">
		<table class="form">
			<tr>
				<td><strong>Platí od</strong></td>
				<td><input type="text" name="den_od" value="'. $cfg['den_od'] .'" size="6" /></td>
				<td class="rpad">Číselná hodnota určuje o kolik dnů je implicitně posunut datum platnosti nastavení.</td>
			</tr>
			<tr>
				<td><strong>Platí do</strong></td>
				<td><input type="text" name="den_do" value="'. $cfg['den_do'] .'" size="6" /></td>
				<td class="rpad">Číselná hodnota určuje o kolik dnů je implicitně posunut datum platnosti nastavení.</td>
			</tr>
			<tr>
				<td><strong>CRON</strong></td>
				<td>';
        // vykresleni selectu
        $output.="<select name='cron'>" . _renderOptions($cron, _post('cron', $cfg['cron'])) . "</select>";

		$output .= '</td>
				<td class="rpad">Časový interval spuštění CRON úlohy.</td>
			</tr>
			<tr>
				<td colspan="3">' . _xsrfProtect() . '<input type="submit" name="save" value="' . $_lang['global.save'] . '" /></td>
			</tr>
		</table>
	</form>
</fieldset>';
	break;

	case 'install':
		$output .= installUG();
	break;

	case 'uninstall':
		$output .= _formMessage(2, "Deinstalace vymaže všechny údaje uložené v databázi!");
		$output .= '<form action="" method="POST">';
		$output .= '<input type="submit" name="deinstall" value="Odinstalovat" />';
		$output .= '<input type="hidden" name="_security_token" value="'. _xsrfToken() .'" />';
		$output .= '</form>';
	break;
}
